var emphasisTimer = null;
var timeoutId = null;
var textRGB = "0,0,0";

function selectVerse(className, showContextMenu) {
	var elements = document.getElementsByClassName(className);
	if (elements.length == 0) { return; }
	elements[0].className = elements[0].className + " selected";

	var verses = document.getElementsByClassName('verse');
	for (var i=0; i<verses.length; i++) {
		if (verses[i].className.indexOf("selecting") == -1) {
			verses[i].className = verses[i].className+' selecting';
		}
	}

	// turn off highlight color when selecting
	var highlights = document.getElementsByClassName('highlighted');
	for (var i=0; i<highlights.length; i++) {
		highlights[i].style.backgroundColor=bodyBgColor;
		highlights[i].style.color=bodyFgColor;
	}

	updateSelectedVerseContents();

	if (showContextMenu) {
	    android.showContextMenu();
    }
}
function deselectVerse(className) {
	var elements = document.getElementsByClassName(className);
	if (elements.length == 0) { return; }

	elements[0].className = elements[0].className.replace(/\s*selected\s*/ig, ' ');

	purgeSelectingClass();
	updateSelectedVerseContents();
}

function updateSelectedVerseContents() {
	var elements = document.getElementsByClassName("verse");
	if (elements.length == 0) { return; }
	var contents = '';
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].className.indexOf("selected") > -1) {
			contents += elements[i].innerHTML;
		}
	}

	contents = contents.replace(/<span class="h2">[\s\S]*?<\/span>/g, '');
	contents = contents.replace(/&nbsp;/ig, ' ').replace(/<strong>.*?<\/strong>/g, '');
	contents = contents.replace(/<br\s*\/?>/ig, '\n').replace(/<a [\s\S]*?\/a>/g, '').replace(/<[\s\S]*?>/sg, '');
	contents = contents.replace(/\n\n+/g, '\n\n');

	android.setSelectedVerseContents(contents);
}

function purgeSelectingClass() {
	var selected = document.getElementsByClassName('selected');
	if (selected.length > 0) { return; }

	var verses = document.getElementsByClassName('verse');
	for (var i=0; i<verses.length; i++) {
		verses[i].className = verses[i].className.replace(/\s*selecting\s*/ig, ' ')
	}

	// turn off highlight color when selecting
	var highlights = document.getElementsByClassName('highlighted');
	for (var i=0; i<highlights.length; i++) {
		var h = highlights[i];
		var strong = h.getElementsByTagName('strong')[0];

		highlights[i].style.backgroundColor=strong.style.backgroundColor;
		highlights[i].style.color=strong.style.color;
	}
}

function scrollToVerse(osis) {
	osis = osis.replace(/\./ig, '_');
	var verse = document.getElementsByClassName(osis);
	android.scrollTo(verse[0].offsetTop);
}
function clearSelection() {
	var elements = document.getElementsByClassName("verse");
	for (var i = 0; i < elements.length; i++) {
		elements[i].className = elements[i].className.replace(/\s*(selected|selecting)\s*/ig, ' ');
	}

	purgeSelectingClass();
}
function selectThenShowContextMenu(x, y) {
	var e = document.elementFromPoint(x, y);
	if (e == null) { return; }
	var className = e.className;

	if (className.indexOf('trans') > -1 || className.indexOf('study') > -1) {
		return;
	}

	// look for verse parent
	while (e != null && className.indexOf('verse') == -1) {
		e = e.parentElement;
		if (e != null) {
		    className = e.className;
		}
	}

	if (e == null) { return; }

	if (className.indexOf('verse') > -1) {
		var verse = className.replace(/.*\b([a-zA-Z0-9]+_\d+_\d+).*/ig, '$1');
		android.selectThenShowContextMenu(verse);
	}
}

function performVerseClick(x, y) {
	var e = document.elementFromPoint(x, y);
	if (e == null) { return; }
	var className = e.className;

	if (className.indexOf('trans') > -1 || className.indexOf('study') > -1) {
		return;
	}

	// look for verse parent
	while (e != null && className.indexOf('verse') == -1) {
		e = e.parentElement;
		if (e != null) {
		    className = e.className;
		}
	}

	if (e == null) { return; }

	if (className.indexOf('verse') > -1) {
		var verse = className.replace(/.*\b([a-zA-Z0-9]+_\d+_\d+).*/ig, '$1');
		var contains = className.indexOf('selected') > -1;
		if (contains) {
			android.deselect(verse);
		}
		else {
			android.select(verse);
		}
	}
}
function handleClick (e) {
	var className = e.className;
	if (className.indexOf('trans') > -1 || className.indexOf('study') > -1) {
		android.showNote(className, e.title);
		return false;
	}
}

function updateOffsets() {
  var d = window.document.body;
  var scroll = d.scrollTop;
  var verses = d.getElementsByClassName('verse');
  var offsets = [];

  for (var i = 0; i < verses.length; i++) {
  	var y = calcOffset(verses[i]);

		// check for overlap and prefer the last verse that appears
  	if (y <= offsets[i - 1]) {
  		// try to push the bottom of the previous verse back enough that this will take over
  		offsets[i - 1] = Math.max(45, offsets[i - 1] - 45);
  	}

		offsets.push(y + verses[i].offsetHeight);
  }

	android.setVerseOffsets(offsets.join(","));
}

function calcOffset(obj) {
	var curtop = 0;

	if (obj != null) {
		curtop = 0;
		if (obj.offsetParent) {
			while (obj.offsetParent) {
				curtop += obj.offsetTop;
				obj = obj.offsetParent;
			}
		} else if (obj.y) {
			curtop += obj.y;
		}
	}

	return curtop;
}

/** verse ranges **/
var hidden = [];
function showAll(e) {
	for (var i = 0; i < hidden.length; i++) {
		hidden[i].style.display="";
	}
	hidden = [];

	hideNotice();
}

function hideNotice() {
	document.getElementById('notice').style.display="none";

	android.clearVerseFromTitle();
	updateOffsets();
}


function showRange(osis, verses) {
	if (typeof(osis) === 'undefined') { return; }
	if (typeof(verses) === 'undefined') { return; }

	var temp, i;
	var verseElems = [];

	for (i=0; i<verses.length; i++) {
		temp = document.getElementsByClassName(osis + '_' + verses[i]);
		if (temp.length > 0) {
			verseElems.push(temp[0]);
		}
	}

	alert('verse elems length: ' + verseElems.length);

	if (verseElems.length === 0) {
		hideNotice();
		return;
	}

	// sanity check, DOM depth mismatch
	temp = verseElems[0];
	for (i=1; i<verseElems.length; i++) {
		if (temp.parentElement.parentElement !== verseElems[i].parentElement.parentElement) {
			alert('sanity check fail: dom depth mismatch');
			return;
		}

		temp = verseElems[i];
	}

	var container = temp.parentElement.parentElement;
	var parentSiblings = container.children;
	var size = parentSiblings.length;

	for (i = 0; i < parentSiblings.length; i++) {
		var sibling = parentSiblings[i];
		var children = sibling.children;
		var j;
		for (j=0; j<children.length; j++) {
			var child = children[j];
			if (verseElems.indexOf(child) === -1) {
				hidden.push(child);
				child.style.display="none";
			}
		}
	}

	// hide headings
	var headings = document.getElementsByClassName('h2');
	for (i=0; i<headings.length; i++) {
		hidden.push(headings[i]);
		headings[i].style.display="none";
	}
}

function clearHighlights() {
	var verses = document.getElementsByClassName('verse');
	for (var i=0; i<verses.length; i++) {
		var e = verses[i];
		e.style.color='';
		e.style.backgroundColor='';
		e.className = e.className.replace(/\s*highlighted\s*/g, ' ');

		var verseNum = verses[i].getElementsByTagName('strong')[0];
		verseNum.style.color='';
		verseNum.style.backgroundColor='';
	}
}
function setHighlights(arr) {
	clearHighlights();

	for (var i=0; i<arr.length; i++) {
		var obj = eval("("+arr[i]+")");
		var v = document.getElementsByClassName(obj['className'])[0];

		v.className = v.className+' highlighted';
		v.style.color=obj['fgColor'];
		v.style.backgroundColor=obj['bgColor'];

		var verseNum = v.getElementsByTagName('strong')[0];
		verseNum.style.color=obj['fgColor'];
		verseNum.style.backgroundColor=obj['bgColor'];
	}
}
